import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'questionnaire' },
})
export class Questionnaire extends BaseModel {
  @prop({
    required: false,
    index: true,
    zh: '类型',
    remark: '字典：wenjuan-questionnaire-type',
  })
  type: string;
  @prop({ required: false, index: true, zh: '标题' })
  title: string;
  @prop({ required: false, index: true, zh: '发布时间' })
  create_date: string;
  @prop({ required: false, index: false, zh: '简介' })
  brief: string;
  @prop({ required: false, index: false, zh: '问卷题库' })
  questions: Array<any>;
  @prop({
    required: false,
    index: true,
    zh: '是否启用',
    remark: '字典：common_use',
    default: '0',
  })
  is_use: string;
}
