import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_answer {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '问卷id' })
  'questionnaire_id': string = undefined;
  @ApiProperty({ description: '用户id' })
  'user_id': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '答案' })
  'answer': Array<any> = undefined;
  @ApiProperty({ description: '用户姓名' })
  'user_name': string = undefined;
  @ApiProperty({ description: '答题时间' })
  'answer_date': string = undefined;
}

export class QDTO_answer extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
}

export class QVO_answer extends FVO_answer {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_answer {
  @ApiProperty({ description: '问卷id' })
  @Rule(RuleType['string']().empty(''))
  'questionnaire_id': string = undefined;
  @ApiProperty({ description: '用户id' })
  @Rule(RuleType['string']().empty(''))
  'user_id': string = undefined;
  @ApiProperty({ description: '手机号' })
  @Rule(RuleType['string']().empty(''))
  'phone': string = undefined;
  @ApiProperty({ description: '答案' })
  @Rule(RuleType['array']().empty(''))
  'answer': Array<any> = undefined;
  @ApiProperty({ description: '用户姓名' })
  @Rule(RuleType['string']().empty(''))
  'user_name': string = undefined;
  @ApiProperty({ description: '答题时间' })
  @Rule(RuleType['string']().empty(''))
  'answer_date': string = undefined;
}

export class CVO_answer extends FVO_answer {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_answer extends CDTO_answer {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_answer extends FVO_answer {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
